SystemOrganization addCategory: #MarianoBuilder!

Object subclass: #ConfigurationOfMariano
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!ConfigurationOfMariano class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMariano class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/20/2011 20:52'!
buildCogVMImage
	(self project version: #bleedingEdge) load: 'CogVMImage'.
	CogVMImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/16/2011 00:08'!
buildDBXTalklmage
	(self project version: #bleedingEdge) load: 'DBXTalkImage'.
	DBXTalkImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/15/2011 23:52'!
buildFuelmage
	(self project version: #bleedingEdge) load: 'FuelImage'.
	FuelImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/15/2011 23:57'!
buildMarealmage
	(self project version: #bleedingEdge) load: 'MareaImage'.
	MareaImageBuilder new buildImage.! !

!ConfigurationOfMariano class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMariano class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMariano class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/20/2011 19:55'!
loadCogVM
	(self project version: #bleedingEdge) load: 'CogVM'.! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/20/2011 19:29'!
loadDBXTalk
	(self project version: #bleedingEdge) load: 'DBXTalk'.! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/15/2011 23:46'!
loadFuel
	(self project version: #bleedingEdge) load: 'Fuel'.
	(Smalltalk at: #FuelUtilities) cleanUpEverything.! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/20/2011 19:29'!
loadMarea
	(self project version: #bleedingEdge) load: 'Marea'.! !

!ConfigurationOfMariano class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/20/2011 17:25'!
loadTextLint
	(self project version: #bleedingEdge) load: 'TextLint'.! !

!ConfigurationOfMariano class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^self new project! !

!ConfigurationOfMariano class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMariano methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 10/20/2011 20:52'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		spec blessing: #baseline.
                "spec repository: 'http://www.squeaksource.com/Fuel'.    "


		spec
			project: 'Fuel' with: [
			spec
				className: 'ConfigurationOfFuel';
				loads: #('CoreWithExtras' 'Tests' 'Benchmarks' 'FuelProgressUpdateBenchmarks' 'FuelLogo' 'Examples' 'PackageLoaderWithTests' 'FuelContainer' );
				file: 'ConfigurationOfFuel';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].

		spec
			project: 'Marea' with: [
			spec
				className: 'ConfigurationOfMarea';
				loads: #('default' );
				file: 'ConfigurationOfMarea';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/Marea' ].
			
			
		spec
			project: 'DBXTalk' with: [
			spec
				className: 'ConfigurationOfGlorpDBX';
				loads: #('default' );
				file: 'ConfigurationOfGlorpDBX';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		
		spec
			project: 'CogVM' with: [
			spec
				className: 'ConfigurationOfCog';
				loads: #('default' );
				file: 'ConfigurationOfCog';
				"Don't use #bleedingEdge because we need to be in zinc with platform code"
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
					
		spec
			project: 'TextLint' with: [
			spec
				className: 'ConfigurationOfTextLint';
				loads: #('default' );
				file: 'ConfigurationOfTextLint';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/textlint' ].
					
		spec
			project: 'SandcastlesThemes' with: [
			spec
				className: 'ConfigurationOfSandcastleThemes';
				loads: #('default');
				file: 'ConfigurationOfSandcastleThemes';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/SandcastlesThemes' ].
		
		spec
			project: 'TilingWindowManager' with: [
			spec
				className: 'ConfigurationOfTilingWindowManager';
				loads: #('default');
				file: 'ConfigurationOfTilingWindowManager';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/TilingWindowManager' ].
		
		spec
			project: 'Glamoroust' with: [
			spec
				className: 'ConfigurationOfGlamoroust';
				loads: #('GT-Inspector' 'GT-Playground' );
				file: 'ConfigurationOfGlamoroust';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/glamoroust' ].
		
		spec project: 'Keymapping' with: [
			spec
				className: 'ConfigurationOfKeymapping';
				loads: #('forDeveloper' );
				file: 'ConfigurationOfKeymapping';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/ShortWays' ].
		
		
		spec 
			package: 'CodeStats' with: [  spec repository: 'http://www.squeaksource.com/MarianoPhD'];
			package: 'SimpleLogger' with: [  spec repository: 'http://www.squeaksource.com/MarianoPhD'].
			
		spec
			group: 'FuelImage' with: #( 'BaseImage' 'SandcastlesThemes' 'Fuel');
			group: 'MareaImage' with: #( 'BaseImage' 'Marea');
			group: 'DBXTalkImage' with: #( 'BaseImage' 'DBXTalk');
			group: 'CogVMImage' with: #( 'BaseImage' 'CogVM');
			
			group: 'BaseImage' with: #('TilingWindowManager' 'SimpleLogger' 'CodeStats' 'Glamoroust' 'Keymapping').

		 ].
	! !

!ConfigurationOfMariano methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #GeneralImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

GeneralImageBuilder subclass: #CogVMImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!CogVMImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 20:34'!
baseImageName
	^ 'CogVMGenerator'! !

!CogVMImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 23:16'!
customPreferences
	self openHelpWorkspace ! !

!CogVMImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 20:34'!
imageDirectory
	"This directory is not by chance. This is the special place where I have the downloaded platform code from git. Hence, I can then easily build the VM"
	^ '/Users/mariano/Pharo/VM/git/cogVMMaster/blessed/image/'! !

!CogVMImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 23:14'!
openHelpWorkspace
	Smalltalk tools workspace openContents: 'CogMTMacOSConfig generateWithSources.
CogMacOSDebugConfig generateWithSources.

"
cd Users/mariano/Pharo/VM/git/cogVMMaster/blessed/build
rm CMakeCache.txt
cmake .
make
"'
! !

GeneralImageBuilder subclass: #DBXTalkImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!DBXTalkImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 22:37'!
baseImageName
	^ 'DBXTalk'! !

!DBXTalkImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/16/2011 23:17'!
customPreferences
	LogoImageMorph default: (ImageMorph withForm: (ImageReadWriter formFromFileNamed: '/Users/mariano/DBXTalk/logo/DBXTALK 4-6_small.png')).
	PolymorphSystemSettings desktopColor: (Color r: 0.7030000000000001 g: 0.6930000000000001 b: 0.6930000000000001).
	Debugger logFileName: 'DBXTalkDebug.log'.
	
! !

!DBXTalkImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 22:38'!
imageDirectory
	^ '/Users/mariano/DBXTalk/imagenes/'! !

GeneralImageBuilder subclass: #FuelImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!FuelImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 21:10'!
baseImageName
	^ 'Fuel'! !

!FuelImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/16/2011 23:17'!
customPreferences
	(Smalltalk at: #FLLogoUtilities) installLogo.
	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/PhD/Marea/Fuel/fotos/1997_Need_For_Speed_2_Special_Edition.jpg'.
	(Smalltalk at: #SandcastlePharoway) beCurrent.
	Debugger logFileName: 'FuelDebug.log'.
	
! !

!FuelImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 21:19'!
imageDirectory
	^ '/Users/mariano/PhD/Marea/Fuel/imagenes/'! !

!GeneralImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 23:16'!
buildImage
	self generalPreBuilt.
	self generalImagePreferences.
	self customPreferences.
	self cleanSystem.
	self saveImage.! !

!GeneralImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2011 23:29'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].
	ScriptLoader new cleanUpForRelease.	
	Author fullName: 'MarianoMartinezPeck'.
	! !

!GeneralImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 17:19'!
generalImagePreferences
	UITheme currentSettings fastDragging: true.
	CodeHolder showAnnotationPane: true.
	MCCodeTool showAnnotationPane: true.
	Deprecation raiseWarning: true.
	Debugger alwaysOpenFullDebugger: true.
	Parser warningAllowed: true. 
	TasklistMorph keepOpen: true.
	AutotestDashboard showAutotestDashboard: true.
	(Smalltalk at: #TWMBar) showTWMBar: true.
	Smalltalk tools register: (Smalltalk at: #GTInspector)  as: #basicInspector.
	" GTPlayground is not yet working correctly, so I disable it for the moment"
	"Smalltalk tools register: (Smalltalk at: #GTPlayground)  as: #workspace."

	! !

!GeneralImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2011 23:16'!
generalPreBuilt
	MCDirectoryRepository defaultDirectoryName: '/Users/mariano/Pharo/localRepo/'.
	Scanner allowUnderscoreAsAssignment: true.
	String allowUnderscore. 

! !

!GeneralImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 21:09'!
saveImage

	Smalltalk saveAs: self baseImageName inDirectoryNamed: self imageDirectory
! !

GeneralImageBuilder subclass: #MareaImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarianoBuilder'!

!MareaImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 22:37'!
baseImageName
	^ 'Marea'! !

!MareaImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/16/2011 23:18'!
customPreferences
	LogoImageMorph default: (ImageMorph withForm: (ImageReadWriter formFromFileNamed: '/Users/mariano/PhD/Marea/kitmarea/mareaLogo.png')).
	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/PhD/Marea/kitmarea/mareaBackground.jpg'.
	Debugger logFileName: 'MareaDebug.log'.	
! !

!MareaImageBuilder methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2011 22:38'!
imageDirectory
	^ '/Users/mariano/PhD/Marea/imagenes/'! !

!SmalltalkImage methodsFor: '*MarianoBuilder' stamp: 'MarianoMartinezPeck 10/17/2011 21:06'!
saveAs: imageName inDirectoryNamed: aDirectoryString

	| newName index |
	
	(FileDirectory default fileExists: (aDirectoryString , imageName, '.' , FileDirectory changeSuffix))
		ifTrue: [
			newName := FileDirectory default nextNameFor: imageName extension: FileDirectory imageSuffix.
			newName := UIManager default
				request: 'Please enter the name for the new image:'
				initialAnswer: newName.
			index := newName findLast: [:c | c = $.].
			newName := newName copyFrom: 1 to: (index - 1).
			
			]
		ifFalse: [ newName := imageName ].
	newName isEmptyOrNil
		ifTrue: [ ^ self ].
	(SourceFiles at: 2) ifNotNil:
		[self closeSourceFiles; "so copying the changes file will always work"
			 saveChangesInFileNamed: (aDirectoryString , newName, '.' , FileDirectory changeSuffix)].
	^self saveImageInFileNamed: (aDirectoryString , newName, '.', FileDirectory imageSuffix)! !
